#pragma semicolon 1

#include <sourcemod>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP Module (Chat)",
	author	= "wS",
	version = "1.2.1"
};

new const String:g_sItemName[] = "chat";
new g_ItemID;
new String:g_sMyChat[MAXPLAYERS + 1][100];
new Handle:g_hIgnoredPhrasesAr = INVALID_HANDLE;
new Float:g_fChatFlood, Float:g_fLastTime[MAXPLAYERS + 1];

public OnPluginStart()
{
	if ((g_ItemID = VIP_RegisterItem(g_sItemName, true, true)) < 1)
		SetFailState("VIP_RegisterItem error");

	wS_ReloadIgnoredPhrases();
	AddCommandListener(SayHook, "say");

	new Handle:cvar	= CreateConVar("vip_chat_flood", "1.0", "Задержка между чат сообщениями в секундах", _, true, 0.1);
	g_fChatFlood	= GetConVarFloat(cvar);
	HookConVarChange(cvar,	cvar_changed);
	AutoExecConfig(true,	"config",	"vip/modules/chat");
}

public cvar_changed(Handle:cvar, const String:OldValue[], const String:NewValue[])
{
	g_fChatFlood	= StringToFloat(NewValue);
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	MarkNativeAsOptional("BfWriteByte");
	MarkNativeAsOptional("BfWriteString");

	return APLRes_Success;
}

public OnPluginEnd()
{
	VIP_UnRegisterItem(g_sItemName);
}

public OnMapEnd()
{
	wS_ReloadIgnoredPhrases();
}

public OnClientConnected(client)
{
	g_sMyChat[client][0] = '\0';
	g_fLastTime[client]  = 0.0;
}

stock bool:wS_Flood(client)
{
	new Float:GameTime_value = GetGameTime();
	if ((GameTime_value - g_fLastTime[client]) < g_fChatFlood)
	{
		g_fLastTime[client] = GameTime_value;
		return true;
	}
	g_fLastTime[client] = GameTime_value;
	return false;
}

public VIP_OnClientAuthorized(client, const String:steamid[], bool:vip, const String:group[])
{
	if (vip) wS_Check(client);
}

public VIP_OnVipItemToggled(client, ItemID, const String:ItemName[], const String:ItemInfo[], bool:enabled)
{
	if (ItemID == g_ItemID)
	{
		if (enabled)
		{
			strcopy(g_sMyChat[client], 100, ItemInfo);
			wS_Replace(g_sMyChat[client]);
		}
		else
			g_sMyChat[client][0] = '\0';

		VIP_ShowMenu(client);
	}
}

public VIP_OnRemoved(client, const String:steamid[], const String:reason[])
{
	g_sMyChat[client][0] = '\0';
}

public VIP_OnGroupChanged(client, const String:steamid[], const String:OldGroup[], const String:NewGroup[])
{
	g_sMyChat[client][0] = '\0';
	wS_Check(client);
}

public VIP_OnAdded(client, const String:steamid[], const String:group[], min, const String:admin_steamid[])
{
	if (client > 0) wS_Check(client);
}

wS_Check(client)
{
	if (!VIP_ItemDisabled(g_sItemName) && VIP_GetItemToggledStatus(client, g_sItemName))
	{
		if (VIP_GetClientItemInfo(client, g_sItemName, g_sMyChat[client])) wS_Replace(g_sMyChat[client]);
		else g_sMyChat[client][0] = '\0';
	}
}

public Action:SayHook(client, const String:command[], args)
{
	if (!(0 < client <= MaxClients))
		return Plugin_Continue;

	if (wS_Flood(client))
		return Plugin_Handled;

	if (g_sMyChat[client][0] == '\0')
		return Plugin_Continue;

	static String:text[256], String:sMyChat[100];

	text[0] = '\0';
	GetCmdArgString(text, 256);
	StripQuotes(text);

	if (TrimString(text) < 1)
		return Plugin_Handled;

	if (text[0] != '!' && text[0] != '/' && text[0] != '@' && FindStringInArray(g_hIgnoredPhrasesAr, text) < 0)
	{
		sMyChat[0] = '\0';
		strcopy(sMyChat, 100, g_sMyChat[client]);

		decl String:name[MAX_NAME_LENGTH];
		if (GetClientName(client, name, MAX_NAME_LENGTH))
			ReplaceString(sMyChat, 100, "{name}", name, false);

		if (ReplaceString(sMyChat, 100, "{team}", "\x03", false) < 1 || !wS_StartMessage(client, sMyChat, text))
		{
			if(!IsPlayerAlive(client))
			{
				SendMSGtoDeath("\x01%s%s", sMyChat, text);
			}
			else
			{
				PrintToChatAll("\x01%s%s", sMyChat, text);
			}
		}

		return Plugin_Handled;
	}

	return Plugin_Continue;
}

wS_ReloadIgnoredPhrases()
{
	if (g_hIgnoredPhrasesAr == INVALID_HANDLE) g_hIgnoredPhrasesAr = CreateArray(100);
	else ClearArray(g_hIgnoredPhrasesAr);

	new Handle:hFile = OpenFile("cfg/vip/modules/chat/ignore.txt", "r");
	if (hFile != INVALID_HANDLE)
	{
		decl String:cmd[100];
		while (!IsEndOfFile(hFile) && ReadFileLine(hFile, cmd, 100))
		{
			if (TrimString(cmd) > 0 && IsCharAlpha(cmd[0]) && FindStringInArray(g_hIgnoredPhrasesAr, cmd) < 0)
			{
				PushArrayString(g_hIgnoredPhrasesAr, cmd);
			}
		}
		CloseHandle(hFile);
	}
}

wS_Replace(String:text[100])
{
	ReplaceString(text, 100, "{text}",			"",		false);
	ReplaceString(text, 100, "{default}",		"\x01", false);
	ReplaceString(text, 100, "{red}",			"\x02", false);
	ReplaceString(text, 100, "{lightgreen}",	"\x03", false);
	ReplaceString(text, 100, "{purple}",		"\x03", false);
	ReplaceString(text, 100, "{green}",			"\x04", false);
	ReplaceString(text, 100, "{darkgreen}",		"\x05", false);
	ReplaceString(text, 100, "{lime}",			"\x06", false);
	ReplaceString(text, 100, "{lightred}",		"\x07", false);
	ReplaceString(text, 100, "#",				"\x07",	false);
}

bool:wS_StartMessage(client, const String:sMyChat[], String:text[256])
{
	new Handle:hMsg		= StartMessageAll("SayText2");
	if (hMsg == INVALID_HANDLE)
		return false;

	Format(text, 256,	"\x01%s%s", sMyChat, text);
	BfWriteByte(hMsg,	client);
	BfWriteByte(hMsg,	true);
	BfWriteString(hMsg,	text);
	EndMessage();

	return true;
}

stock SendMSGtoDeath(const String:MSG[],any:...)
{
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && !IsFakeClient(i) && !IsPlayerAlive(i))
		{
			PrintToChat(i,"%s",MSG);
		}
	}
}